// =================== DO NOT EDIT THIS FILE ====================
// Generated by Modello 1.7,
// any modifications will be overwritten.
// ==============================================================

package org.apache.archiva.redback.keys.jdo.io.stax;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.OutputStream;
import java.io.StringWriter;
import java.io.Writer;
import java.text.DateFormat;
import java.util.Iterator;
import java.util.Locale;
import java.util.jar.Manifest;
import javax.xml.stream.*;
import org.apache.archiva.redback.keys.jdo.AuthenticationKeyDatabase;
import org.apache.archiva.redback.keys.jdo.JdoAuthenticationKey;

/**
 * Class RedbackKeyManagementJdoStaxWriter.
 * 
 * @version $Revision$ $Date$
 */
public class RedbackKeyManagementJdoStaxWriter
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field curId.
     */
    private int curId;

    /**
     * Field idMap.
     */
    private java.util.Map idMap;


      //----------------/
     //- Constructors -/
    //----------------/

    public RedbackKeyManagementJdoStaxWriter()
    {
        idMap = new java.util.HashMap();
    } //-- org.apache.archiva.redback.keys.jdo.io.stax.RedbackKeyManagementJdoStaxWriter()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write.
     * 
     * @param writer
     * @param authenticationKeyDatabase
     * @throws java.io.IOException
     * @throws XMLStreamException
     */
    public void write( Writer writer, AuthenticationKeyDatabase authenticationKeyDatabase )
        throws java.io.IOException, XMLStreamException
    {
        XMLOutputFactory factory = XMLOutputFactory.newInstance();
        boolean supportWindowsLineEndings = false;
        if ( factory.isPropertySupported( "com.ctc.wstx.outputEscapeCr" ) )
        {
            factory.setProperty( "com.ctc.wstx.outputEscapeCr", Boolean.FALSE );
            supportWindowsLineEndings = true;
        }
        if ( factory.isPropertySupported( "org.codehaus.stax2.automaticEmptyElements" ) )
        {
            factory.setProperty( "org.codehaus.stax2.automaticEmptyElements", Boolean.FALSE );
        }
        IndentingXMLStreamWriter serializer = new IndentingXMLStreamWriter( factory.createXMLStreamWriter( writer ) );
        if ( supportWindowsLineEndings )
        {
            serializer.setNewLine( serializer.getLineSeparator() );
        }
        serializer.writeStartDocument( authenticationKeyDatabase.getModelEncoding(), "1.0" );
        writeAuthenticationKeyDatabase( authenticationKeyDatabase, "authenticationKeyDatabase", serializer );
        serializer.writeEndDocument();
    } //-- void write( Writer, AuthenticationKeyDatabase )

    /**
     * Method write.
     * 
     * @param stream
     * @param authenticationKeyDatabase
     * @throws java.io.IOException
     * @throws XMLStreamException
     */
    public void write( OutputStream stream, AuthenticationKeyDatabase authenticationKeyDatabase )
        throws java.io.IOException, XMLStreamException
    {
        XMLOutputFactory factory = XMLOutputFactory.newInstance();
        boolean supportWindowsLineEndings = false;
        if ( factory.isPropertySupported( "com.ctc.wstx.outputEscapeCr" ) )
        {
            factory.setProperty( "com.ctc.wstx.outputEscapeCr", Boolean.FALSE );
            supportWindowsLineEndings = true;
        }
        if ( factory.isPropertySupported( "org.codehaus.stax2.automaticEmptyElements" ) )
        {
            factory.setProperty( "org.codehaus.stax2.automaticEmptyElements", Boolean.FALSE );
        }
        IndentingXMLStreamWriter serializer = new IndentingXMLStreamWriter( factory.createXMLStreamWriter( stream, authenticationKeyDatabase.getModelEncoding() ) );
        if ( supportWindowsLineEndings )
        {
            serializer.setNewLine( serializer.getLineSeparator() );
        }
        serializer.writeStartDocument( authenticationKeyDatabase.getModelEncoding(), "1.0" );
        writeAuthenticationKeyDatabase( authenticationKeyDatabase, "authenticationKeyDatabase", serializer );
        serializer.writeEndDocument();
    } //-- void write( OutputStream, AuthenticationKeyDatabase )

    /**
     * Method writeAuthenticationKeyDatabase.
     * 
     * @param authenticationKeyDatabase
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     * @throws XMLStreamException
     */
    private void writeAuthenticationKeyDatabase( AuthenticationKeyDatabase authenticationKeyDatabase, String tagName, XMLStreamWriter serializer )
        throws java.io.IOException, XMLStreamException
    {
        if ( authenticationKeyDatabase != null )
        {
            serializer.writeStartElement( tagName );
            if ( ( authenticationKeyDatabase.getKeys() != null ) && ( authenticationKeyDatabase.getKeys().size() > 0 ) )
            {
                serializer.writeStartElement( "keys" );
                for ( Iterator iter = authenticationKeyDatabase.getKeys().iterator(); iter.hasNext(); )
                {
                    JdoAuthenticationKey o = (JdoAuthenticationKey) iter.next();
                    writeJdoAuthenticationKey( o, "key", serializer );
                }
                serializer.writeEndElement();
            }
            serializer.writeEndElement();
        }
    } //-- void writeAuthenticationKeyDatabase( AuthenticationKeyDatabase, String, XMLStreamWriter )

    /**
     * Method writeJdoAuthenticationKey.
     * 
     * @param jdoAuthenticationKey
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     * @throws XMLStreamException
     */
    private void writeJdoAuthenticationKey( JdoAuthenticationKey jdoAuthenticationKey, String tagName, XMLStreamWriter serializer )
        throws java.io.IOException, XMLStreamException
    {
        if ( jdoAuthenticationKey != null )
        {
            serializer.writeStartElement( tagName );
            if ( jdoAuthenticationKey.getKey() != null )
            {
                serializer.writeStartElement( "key" );
                serializer.writeCharacters( jdoAuthenticationKey.getKey() );
                serializer.writeEndElement();
            }
            if ( jdoAuthenticationKey.getForPrincipal() != null )
            {
                serializer.writeStartElement( "forPrincipal" );
                serializer.writeCharacters( jdoAuthenticationKey.getForPrincipal() );
                serializer.writeEndElement();
            }
            if ( jdoAuthenticationKey.getPurpose() != null )
            {
                serializer.writeStartElement( "purpose" );
                serializer.writeCharacters( jdoAuthenticationKey.getPurpose() );
                serializer.writeEndElement();
            }
            if ( jdoAuthenticationKey.getDateCreated() != null )
            {
                serializer.writeStartElement( "dateCreated" );
                serializer.writeCharacters( String.valueOf( jdoAuthenticationKey.getDateCreated().getTime() ) );
                serializer.writeEndElement();
            }
            if ( jdoAuthenticationKey.getDateExpires() != null )
            {
                serializer.writeStartElement( "dateExpires" );
                serializer.writeCharacters( String.valueOf( jdoAuthenticationKey.getDateExpires().getTime() ) );
                serializer.writeEndElement();
            }
            serializer.writeEndElement();
        }
    } //-- void writeJdoAuthenticationKey( JdoAuthenticationKey, String, XMLStreamWriter )

}
